'Frequenzeinstellung fr ICOM- Amateurfunkgerte

' Keyboardmatrix liegt an PortB
' Spalten von links nach rechts: PB0, PB1, PB2, PB3
' Reihen von oben nach unten: PB4, PB5, PB6, PB7

' Keyboardaufbau
'
'   1  2  3
'   4  5  6
'   7  8  9
'   *  0  #

' Befehl GETKBD mappt letzte Zeile um:                                                          '
'
'   1  2  3
'   4  5  6
'   7  8  9
'   10 11 12

' Quittungston an PD6
' RxD / TxD PD0 / PD1
' Museklavier an PD 2, 3, 4 , 5:  Gertevorwahl und Geschwindigkeit
' PD5 (Schalter"1") : 4800 bit/s
' PD4 (Schalter"2") : 9600 bit/s
' PD3 (Schalter"3") : 4bit-Modus (IC735)
' PD2 (Schalter"4") : nach Reset wird Gerteadresse abgefragt



' Rechengang:

' Frequenz:         1.234.567.890 Hz

' Tastatureingabe:  1234 * 56789 #                  -> <*> ist Ende MHz- Eingabe  <#> ist <Enter>

' Sendefolge Frequenzbytes:  90 78 56 34 12

'
' Frequenz         4.567.890

' Tastatureingabe: 4 * 56789 #

' Sendefolge Frequenzbytes:  90 78 56 04 00


' Frequenz         567 kHz

' Tastatureingabe: 567 #

' Sendefolge Frequenzbytes: 00 07 56 00 00




' Version 2: Powerdown und Pin Change Interrupts eingebaut; dadurch kein
' Ruhestromverbrauch

' Version 3: bugfix
' Version 3a: bugfix  und CLKPR zur Taktumschaltung 1 MHz -> 8 MHz
'
'--------------------------------------------------------------------



$regfile = "attiny2313.dat"
$crystal = 8000000                                          ' Der Controller kann auf 1 MHz Takt (Auslieferungszustand) verbleiben
                                                             ' auf 8 MHz wird weiter unten umgeschaltet
$baud = 19200
$swstack = 32
$hwstack = 8
$framesize = 24


Ddrd = &B0100_0010
Portd = &B1011_1101

Ddrb = &B0000_0000
Portb = &B1111_1111

Porta = &B0000_1111


Dim B As Byte                                               ' Zhlvariablen
Dim I As Byte
Dim N As Byte
Dim M As Byte
Dim P As Byte
Dim Q As Byte
Dim Puffer(12) As Byte                                      ' nimmt die eingegebenen Zeichen auf
Dim Str_len As Byte                                         ' Anzahl eingegebener Zeichen
Dim Freq(10) As Byte                                        ' Frequenz auf 10 Stellen normiert
Dim Pos As Byte                                             ' Position "*"
Dim Fillup As Byte                                          ' Zahl fhrender Nullen bei Formatierung von Freq(n)
Dim Freqbyte(5) As Byte                                     ' 10-stellige Freq wird in 5 Bytes in Sendereihenfolge gewandelt
Dim Max_len As Byte                                         ' Maximale akzeptierte Tastatureingaben
Dim Address As Byte
Dim Num_bytes As Byte

Const Preamble = &HFE                                       ' zwei Bytes, die am Anfang jeden Telegramms stehen mssen
Const Pcaddress = &HE0                                      ' PC- Adresse
Const Setfrq = &H05                                         ' CAT- Befehl "Frequenz einlesen"
Const Eom = &HFD                                            ' muss am Ende des Telegramms stehen

Const Biip = 100                                            ' Laenge Sound
Const Boop = 600
Const Biipfrq = 400                                         ' kleiner ist hher
Const Boopfrq = 1200


Buzzer Alias Portd.6
Rigsel Alias Pind.2
Fourbyte Alias Pind.3
Speed1 Alias Pind.4
Speed2 Alias Pind.5
Config Kbd = Portb , Debounce = 40 , Delay = 100

Gimsk.5 = 1
Sreg.7 = 1
Pcmsk = 255

Clkpr = 128                                                 ' Taktumschaltung vorbereiten
Clkpr = 0                                                   ' Vorteiler auf Teilerverhltnis 1 setzen
Clkpr = 0                                                   ' zur Sicherheit wiederholen





' erst mal Museklavier abfragen:


 If Speed1 = 0 Then
     Baud = 9600
 End If

 If Speed2 = 0 Then
      Baud = 4800
 End If

 Num_bytes = 5

 If Fourbyte = 0 Then
    Num_bytes = 4                                           ' IC735- Modus
 End If




' wenn Rig- Pin aktiviert, Gerteadresse abfragen:
' (Eingabeformat: die zwei Hexziffern jeweils 2-stellig (also mit fhrender 0) eingeben
' Hexziffern > 9 als zwei Ziffern (z.B. D -> 13).  Abschliessen mit "#"
' Beispiele:
' Gerteadresse 68 -> 0608#
' Gerteadresse 4A -> 0410#
' Gerteadresse FE -> 1514#



 If Rigsel = 0 Then

    Max_len = 5                                             ' nach mehr als 5 Zeichen: Fehlermeldung
    Gosub Read_kbd

    For N = 1 To 4

       If Puffer(n) = 0 Then                                ' wenn weniger als 4 Ziffern eingegeben wurden
          Gosub Murks
       End If

       If Puffer(n) = 11 Then                               ' Taste "0" liefert "11"; wird hier durch "0" ersetzt
           Puffer(n) = 0
       End If

    Next


    Address = Puffer(2)                                     ' zweite eingegebene Ziffer

    If Puffer(1) = 1 Then                                   ' ist die erste Ziffer eine "1", 10 addieren
       Address = Address + 10
    End If

    Shift Address , Left , 4                                ' Wert ins obere Halbbyte schieben

    Address = Address + Puffer(4)                           ' vierte eingegebene Ziffer addieren

    If Puffer(3) = 1 Then
       Address = Address + 10                               ' ist die dritte Ziffer eine "1", 10 addieren
    End If

    Writeeeprom Address , 16                                ' Byte ins EEProm an Adresse 16 schreiben

 End If







Main:


Readeeprom Address , 16                                     ' Gerteadresse aus EEProm- Adrssse 16 auslesen


Do

   Max_len = 11
   Gosub Read_kbd



' umsortieren aus Puffer in das 10- Byte Array Freq(n)

   N = 0
   Pos = 0
   Do                                                       ' String (bzw. Array) durchsuchen
      N = N + 1
      If Puffer(n) = 10 Then
          Pos = N                                           ' Position suchen, an der Taste "*" steht
      End If
   Loop Until Puffer(n) = 0                                 ' letztes eingegebenes Zeichen suchen

       Str_len = N - 1                                      ' Stringlenge ist einer weniger
       Fillup = 5 - Pos                                     ' Zahl der fhrenden Nullen in Freq(n)


   If Pos > 0 Then                                          ' es gibt ein Zeichen "*" = 011

     Decr Pos
     For N = 1 To Pos                                       ' die Zeichen im Puffer vor dem "*" hinter die fhrenden "0" in Freq(n) schreiben
        I = N + Fillup
        Freq(i) = Puffer(n)
     Next
     Pos = Pos + 2                                          ' auf das Zeichen hinter dem "*" positionieren
   End If

   If Pos = 0 Then                                          ' wenn es kein "*" gab, bei 1 loslegen
      Incr Pos
   End If

   For N = Pos To Str_len                                   ' die restlichen Zeichen hinter dem "*" in Freq(n) schreiben
      I = N + Fillup
      Decr I
      Freq(i) = Puffer(n)
   Next


' die Taste "0" ist noch mit "11" codiert; 11 durch 0 ersetzen

  For N = 1 To 10
     If Freq(n) = 11 Then
        Freq(n) = 0
     End If
  Next


 ' aus 10 Byes 5 machen und Reihenfolge umstellen

  For M = 1 To 5

     Q = 2 * M
     P = 11 - Q
     Freqbyte(m) = Freq(p)                                  ' ungerade Stellen aus Freq(n) holen
     Shift Freqbyte(m) , Left , 4                           ' vom unteren Nibble ins obere Nibble schieben
     Freqbyte(m) = Freqbyte(m) + Freq(p + 1)                ' gerade Stellen aus Freq(n) ins untere Nibble schreiben

  Next


' komplettes Telegramm senden :

   Print Chr(preamble);
   Print Chr(preamble);
   Print Chr(address);
   Print Chr(pcaddress);
   Print Chr(setfrq);
   For N = 1 To Num_bytes
      Print Chr(freqbyte(n));
   Next
   Print Chr(eom);

   Waitms 500                                               ' Wartezeit, damit UART- Zeichenpuffer geleert werden kann

   Mcucr = &B0111_0000                                      ' Powerdown
   !Sleep
   Mcucr = 0                                                ' Sleep enable aufheben
Loop




Read_kbd:


' Tastatur lesen, mit Lookup umcodieren, Bytes in Array Puffer(n) schreiben

  For N = 1 To 12
     Puffer(n) = 0
  Next
  For N = 1 To 10
     Freq(n) = 0
  Next


  N = 1

  Do

    Restore Matrix

    Do
      B = Getkbd()
    Loop Until B <> 16                                      ' 16 : keine Taste gedrckt

    Puffer(n) = Lookup(b , Matrix)

    Do                                                      ' Prfen, ob Taste losgelassen
       B = Getkbd()
    Loop Until B = 16

    If N > Max_len Then                                     ' Zeichenkette zu lang
       Gosub Murks
       Goto Main                                            ' auf Anfang
    End If

    Gosub Quittung                                          ' Quittungston

    If Puffer(n) = 12 Then                                  ' Taste "Raute" gedrckt
       Puffer(n) = 0                                        ' durch "0" ersetzen
       Gosub Enter                                          ' Eingabe fertig; Rckkehr
       Return
    End If

    Incr N

  Loop

Return






Quittung:

   Sound Buzzer , Biip , Biipfrq

Return


Enter:

   Sound Buzzer , Boop , Biipfrq

Return


Murks:

   Sound Buzzer , Boop , Boopfrq

Return



End




' Data

Matrix:

Data 1 , 2 , 3 , 255 , 4 , 5 , 6 , 255 , 7 , 8 , 9 , 255 , 10 , 11 , 12 , 12